!define MyName "MoyKrytoyMacros"
;  MoyKrytoyMacros        .GMS

;!define DisableDelayLoadVBA
; 			  ;  .     DelayLoadVBA

;      :  gms    

;         :
; MyComputer -> menu Tools -> Folder Options -> FileTypes -> NSI ->> Advanced
;  ->  / ->   ->   -> NSI ->> 
; 	  "Compile NSIS Script"   "Set Default" ( )

;           

;  NSIS - http://nsis.sourceforge.net/Download  

;Icon "icon.ico"
; 			  ;  .         Icon.ico 


SetCompressor lzma
Name "${MyName}"
OutFile "${MyName}.Exe"
InstallDir "$PROGRAMFILES\Corel\CorelDRAW Graphics Suite 13\Draw\Gms\"
InstallColors /windows
CRCCheck on
SetDateSave on
XPStyle on
ShowInstDetails show
LoadLanguageFile "${NSISDIR}\Contrib\Language files\English.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language files\Russian.nlf"

Page components
Page instfiles

var /global cdr11
var /global cdr12
var /global cdr13

!include Sections.nsh

Section /o "${MyName}::CorelDRAW 11" sec11
	SetOutPath "$cdr11\draw\gms\"
	strcpy $0 "Software\Corel\CorelDraw\11.0\CorelDRAW\Application Preferences\VBA - Global Document"
	call UncheckDelayLoadVBA
	strcpy $0 "CorelDRAW 11.0"
	call CheckRunningCorelDRAW
	File ${MyName}.gms
	SectionEnd

Section /o "${MyName}::CorelDRAW 12" sec12
	SetOutPath "$cdr12\draw\gms\"
	strcpy $0 "Software\Corel\CorelDraw\12.0\CorelDRAW\Application Preferences\VBA"
	call UncheckDelayLoadVBA
	strcpy $0 "CorelDRAW 12.0"
	call CheckRunningCorelDRAW
	File ${MyName}.gms
	SectionEnd

Section /o "${MyName}::CorelDRAW X3" sec13
	SetOutPath "$cdr13\draw\gms\"
	strcpy $0 "Software\Corel\CorelDraw\13.0\CorelDRAW\Application Preferences\VBA"
	call UncheckDelayLoadVBA
	strcpy $0 "CorelDRAW 13.0"
	call CheckRunningCorelDRAW
	File ${MyName}.gms
	SectionEnd

Function .onInit
	strcpy $0 "11"
	call checkCorel
	strcpy $cdr11 $1
	ifFileExists "$0" 0 +2
		SectionSetFlags ${sec11} ${SF_SELECTED} 

	strcpy $0 "12"
	call checkCorel
	strcpy $cdr12 $1
	ifFileExists "$0" 0 +2
		SectionSetFlags ${sec12} ${SF_SELECTED} 

	strcpy $0 "13"
	call checkCorel
	strcpy $cdr13 $1
	ifFileExists "$0" 0 +2
		SectionSetFlags ${sec13} ${SF_SELECTED} 
	FunctionEnd

function checkCorel
	ReadRegStr $1 HKLM "SOFTWARE\Corel\CorelDRAW\$0.0" "ConfigDir"
	strcpy $1 $1 -6
	strcpy $0 "$1Programs\coreldrw.exe"
	strCpy $1 $1 -1
	FunctionEnd

function CheckRunningCorelDRAW
	CheckCorel:
	FindWindow $1 $0
	intcmp $1 0 Lignore
	MessageBox MB_ABORTRETRYIGNORE  "Close $0 and press OK" IDRETRY Lretry IDIGNORE Lignore
	abort "Installation aborted"
	Lretry:
		goto CheckCorel
	Lignore:
	FunctionEnd
	
function UncheckDelayLoadVBA
	!ifdef DisableDelayLoadVBA
		WriteRegStr HKCU $0 "DelayLoadVBA" "0"
	!endif
	WriteRegStr HKCU $0 "DesignMode" "0"
	FunctionEnd
	
